package po

import "plugins/union_pay/internal/vo"

type Headers struct {
	SignMethod  string `json:"signmethod" validate:"required"`
	Version     string `json:"version" validate:"required"`
	ContentType string `json:"content-type" validate:"required"`
	AppId       string `json:"appid" validate:"required"`
	BizMethod   string `json:"bizmethod" validate:"required"`
	ReqId       string `json:"reqid" validate:"required"`
	Reqts       string `json:"reqts" validate:"required"`
	Sign        string `json:"sign" validate:"required"`
}

type Body struct {
	CouponNum     interface{}    `json:"couponNum"`
	TraceID       string         `json:"traceId"`
	TransTp       string         `json:"transTp"`
	ChnlID        string         `json:"chnlId"`
	TransChnl     string         `json:"transChnl"`
	CouponNm      string         `json:"couponNm"`
	OperTp        vo.OperaTp     `json:"operTp"`
	CouponCd      string         `json:"couponCd"`
	CouponID      string         `json:"couponId"`
	OrderAt       interface{}    `json:"orderAt"`
	TransSeq      string         `json:"transSeq"`
	PosTmn        string         `json:"posTmn"`
	DiscountAt    interface{}    `json:"discountAt"`
	CouponCdInfos []CouponCdInfo `json:"couponCdInfos"`
	MchntCd       string         `json:"mchntCd"`
	TransDtTm     string         `json:"transDtTm"`
}

type CouponCdInfo struct {
	SubAcctOperAt interface{} `json:"subAcctOperAt"`
	CouponCd      string      `json:"couponCd"`
}

type Notify struct {
	Headers *Headers `json:"headers"`
	Body    *Body    `json:"body"`
}
